local AggroBorder = CreateFrame("FRAME");
AggroBorder:SetScript('OnEvent', function(self, event, ...)
    return self[event] and self[event](self, event, ...)
end)

-- 어글대상 목록 변경
function AggroBorder:UNIT_THREAT_LIST_UPDATE(...)
    local ll = {...};
    local unitId = ll[2];
    
    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitId, issecure());
    if (not plateFrame) then
        return;
    end
    
    -- 어글 표시
    LJDUpdateHealthBorder(plateFrame.UnitFrame);
end
AggroBorder:RegisterEvent('UNIT_THREAT_LIST_UPDATE');

-- 어글상태 변경
function AggroBorder:UNIT_THREAT_SITUATION_UPDATE(...)
    local ll = {...};
    local unitId = ll[2];
    
    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitId, issecure());
    if (not plateFrame) then
        return;
    end
    
    -- 어글 표시
    LJDUpdateHealthBorder(plateFrame.UnitFrame);
end
AggroBorder:RegisterEvent('UNIT_THREAT_SITUATION_UPDATE');

-- 타켓변경
function AggroBorder:UNIT_TARGET(...)

    local ll = {...};
    local unitId = ll[2];
    
    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitId, issecure());
    if (not plateFrame) then
        return;
    end
    
    -- 어글 표시
    -- 엄밀히 Border 변경이랑은 상관없으나
    -- 해당 함수안에서 대상변경 함수를 호출하므로..
    -- (Border도 갱신하면 좋잖아..)
    LJDUpdateHealthBorder(plateFrame.UnitFrame);
end
AggroBorder:RegisterEvent('UNIT_TARGET');

---적대상 이름표 border에 어그로 획득표시
function LJDUpdateHealthBorder(unitFrame)
    if( not unitFrame ) then return; end;
    if( not unitFrame.healthBar ) then return; end;
    if( not unitFrame.healthBar.border ) then return; end;
    if unitFrame:IsForbidden() then return; end;

    if( 1 == 1 ) then 
        --return;
    end

    ------------------------------------------------------
    -- 검정색(초기값)
    -- 단순한 초기값이 아님
    -- 가끔 몹중에서 어글이 없는 몹을 표현하기 위해
    -- 어글 자체가 없음을 의미함.
    ------------------------------------------------------
    unitFrame.healthBar.border:SetVertexColor(0, 0, 0, 1);

    -- 선택대상 강조(아군 포함)
    if (UnitIsUnit ("target", unitFrame.displayedUnit)) then
        -- 흰색
        unitFrame.healthBar.border:SetVertexColor(0.8, 0.8, 0.8, 0.8);

        -- 선택대상 체력바 강조
        --unitFrame.selectionHighlight:SetVertexColor(0.5, 0.5, 0.5, 0.8);
    end

    --[[
        threatStatus
        
        nil = unit is not on otherunit's threat table.
        0 = not tanking, lower threat than tank.(Unit 비 어글, 어글자보다 어글이 낮을때)
        1 = not tanking, higher threat than tank.(Unit 비 어글, 어글자보다 어글이 높을때, 조만간 Unit한테 올듯)
        2 = insecurely tanking, another unit have higher threat but not tanking.(Unit 어글, 다른 유닛이 어글 높음, 조만간 다른 유닛에게 갈듯)
        3 = securely tanking, highest threat(Unit 어글, 최대 어글자)
    --]]
    local threatStatus = UnitThreatSituation("player", unitFrame.displayedUnit);
    --local isTanking, threatStatus, threatpct, rawthreatpct, threatvalue = UnitDetailedThreatSituation ("player", unitFrame.displayedUnit);
    
    --DebugPrint(tostring(threatpct)..":"..tostring(rawthreatpct));
    if( threatStatus ) then
        ----------------------------------------------------------------------------
        -- 진득주)
        -- UNIT_THREAT_LIST_UPDATE, UNIT_THREAT_SITUATION_UPDATE 이벤트가
        -- 어글자가 변경된 후에 오기 때문에
        -- (다른 이벤트에서 처리할 때가 아니면) 중간 단계인 1, 2는 입수되지 않을듯.
        ----------------------------------------------------------------------------
        -- 0 의 색(회색)만 표현됨, 아래에서 어글시는 다른색으로 변경하므로
        -- => 사용안함.
        --local aggrR, aggrG, aggrB = GetThreatStatusColor(threatStatus);
        --unitFrame.healthBar.border:SetVertexColor(aggrR, aggrG, aggrB, 0.8);

        --------------------------
        -- 비 어글
        --------------------------
        -- 빨강
        --unitFrame.healthBar.border:SetVertexColor(1, 0, 0, 0.8);
        -- ?
        unitFrame.healthBar.border:SetVertexColor(0.95, 0.37, 0.37, 0.8);   -- 241, 95, 95 (자주색)
        
        -- 선택 + 비어글 대상 강조
        if (UnitIsUnit ("target", unitFrame.displayedUnit)) then
            -- 노랑
            unitFrame.healthBar.border:SetVertexColor(1, 1, 0, 0.8);
        end
        
        --------------------------
        -- 어글
        --------------------------
        if threatStatus >= 3 then
            --초록
            unitFrame.healthBar.border:SetVertexColor(0, 1, 0, 0.8)
            --unitFrame.healthBar.border:SetVertexColor(0, 0.5, 0.5, 0.8)
            
            -- 선택 + 어글 대상 강조
            if (UnitIsUnit ("target", unitFrame.displayedUnit)) then
                -- 청록
                unitFrame.healthBar.border:SetVertexColor(0, 1, 1, 0.8)
                --unitFrame.healthBar.border:SetVertexColor(0, 1, 1, 0.8)
            end
        end
    end

    -- 유닛이 어글대상이 아닌 대상을 선택하면 표시
    -- ; 여기 둔 이유는 Border의 변경(네임플레이트 생성 및 제거 등) + 어글의 변경등 모두 동일한 이벤트시 동작해야 하므로
    -- (+ 타켓의 변경) 이벤트시에도 호출되어야 함.
    LJDShowUnitTarget(unitFrame);
end
-- 유닛프레임의 Border가 변경될때, 확인결과 아군, 적군 모두 영향을 줌.
-- 동작하지만 가끔 샘..
-- ex) 확인된 문제
-- 유닛프레임이 화면밖으로 나갔다가 다시 들어온 경우
-- 어글이 튀어서 다른 유닛으로 넘어간 경우
-- 주석 처리시 : 어글의 변동없이 선택/해제시 border 표현안됨.
hooksecurefunc("CompactUnitFrame_UpdateHealthBorder", LJDUpdateHealthBorder);

-- 유닛의 대상을 출력한다.
-- (어그로 대상이 아닐때만)
function LJDShowUnitTarget(unitFrame)
    if( not unitFrame ) then return; end;
    if( not unitFrame.healthBar ) then return; end;
    if( not unitFrame.healthBar.border ) then return; end;
    if unitFrame:IsForbidden() then return; end;

    local unitId       = unitFrame.displayedUnit;
    local unitTargetId = unitFrame.displayedUnit.."target";

    -- 타켓이름, 없으면 생성
    if( not unitFrame.TargetNameText ) then
        unitFrame.TargetNameText = unitFrame:CreateFontString(nil, "OVERLAY");
        -- OUTLINE 은 폰트를 굵고 테두리가 표시 되도록하는 옵션이다.
        unitFrame.TargetNameText:SetFont([[Fonts\2002.TTF]], 12, "OUTLINE");
        --unitFrame.TargetNameText:SetSize(10, 10);
        unitFrame.TargetNameText:SetPoint("RIGHT", unitFrame.healthBar.border, "LEFT", -15, 0 );
        unitFrame.TargetNameText:SetJustifyV("TOP");
        unitFrame.TargetNameText:SetJustifyH("LEFT");
        unitFrame.TargetNameText:SetText("대상"); -- 테스트용
        --unitFrame.TargetNameText:Show();
    end

    -- 초기화
    unitFrame.TargetNameText:SetText("");

    -- 플레이어면 제외
    if( UnitIsUnit("player", unitId)  ) then
        return;
    end

    -- 흑마 소환수가 대상이 표현되는 경우 발생하여 아군제외
    if UnitIsFriend("player", unitId) then
        return;
    end
    
    -- 유닛의 대상이 어글대상인지 확인
    local isTanking, threatStatus = UnitDetailedThreatSituation (unitTargetId, unitId);
    --print(unitTargetId, unitId, threatStatus);
    -- 유닛의 대상이 탱커가 아닐때만 대상 표현
    -- 즉, 탱킹중에 다른 유닛에게 스킬을 사용하는 경우를 찾기 위함으로
    -- 레잔의 물어뜯기등의 대상 파악용.
    local targetNameText = "";
    --if( threatStatus and not isTanking ) then   -- 몹이 적대적 대상(즉, 아군)만 선택 변경한걸 보고 싶으면(어글 무시몹 표현안됨)
    if( not isTanking ) then  -- 몹이 자기자신을 선택했을때도 표현하고 싶으면(어글 무시몹 표현 가능.)

        local newName = nil;
        if(UnitIsUnit(unitId, unitTargetId)) then
            newName = "SELF";
        elseif(UnitIsUnit("player", unitTargetId)) then
            newName = "나";
        end
        
        targetNameText = LJDGetClassColoredName(unitTargetId, newName);
        if( targetNameText ) then
            targetNameText = "|cff00ff00대상 |r" .. targetNameText;
            --targetNameText = tostring(threatStatus);
            unitFrame.TargetNameText:SetText(targetNameText);
        end
    end

    
end

-- 이하는 수정 흔적(사용안함)

-- Player 의 대상 변경시 캐스팅스킬툴팁도 숨긴다.
function AggroBorder:PLAYER_TARGET_CHANGED(...)
    local ll = {...};
    --DebugPrint(ll);
    local unitId = ll[2];
    local startSpellId = ll[4];

    -- 유효성체크
    if( not LJDIsValidate() ) then
        return;
    end

    --ItemRefTooltip:Hide();
end
--AggroBorder:RegisterEvent('PLAYER_TARGET_CHANGED');

-- 초기화
function AggroBorder:NAME_PLATE_UNIT_REMOVED(...)
    local ll = {...};
    local unitId = ll[2];

    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitId, issecure());

    if( plateFrame.TargetNameText ) then
        plateFrame.TargetNameText:SetText("");
    end
end
--AggroBorder:RegisterEvent("NAME_PLATE_UNIT_REMOVED");

-- 캐스터바에 대상 표현 추가(실패)
function LJDUpdateSpellName(castBar)

    if castBar:IsForbidden() then return; end;
    if( not castBar.castID ) then return; end;

    -- castID 에서 spellId 추출
    -- ex) Cast-3-3152-1594-26212-258674-0004769DA2
    --   : 258674
    local spellId   = select(6,strsplit("-", castBar.castID));
    local spellName = castBar.Text:GetText();
    local targetName = "";
    
    -- 대상있는 스킬만
    --if( IsAttackSpell(spellName) ) then
        --targetName = "["..LJDGetClassColoredName(castBar.unit.."target").."]";
        targetName = ""..LJDGetClassColoredName(castBar.unit.."target").."";
    --end

    -----------------------------------------
    -- 임시 케바케로 추가한 기능.
    -- 
    -- 스킬설명에 "치유"가 포함되어 있으면 ..
    --[[
    local spellDesc = GetSpellDescription(spellId);
    local startIndex, endIndex = string.find( spellDesc, "치유");
    
    if( startIndex ) then
        targetName = "";
    end
    --]]
    -----------------------------------------

    --DebugPrint(spellName ..": SpellIsSelfBuff ".. tostring(SpellIsSelfBuff(spellId)));
    --DebugPrint(spellName ..": SpellIsTargeting ".. tostring(SpellIsTargeting(spellId)));
    --DebugPrint(spellName ..": IsAttackSpell ".. IsAttackSpell(spellName));
    --DebugPrint(spellName ..": IsHarmfulSpell ".. IsHarmfulSpell(spellId));
    
    --DebugPrint(spellName ..": GetSpellDescription ".. tostring(GetSpellDescription(spellId)));

    local newCastbarText = spellName.." "..targetName;
    
    -- 스킬별 대상을 알지 못하여 스킬사용중의 NPC의 현재대상을 출력하는데는 성공하였으나
    -- NPC가 스스로 치유스킬을 사용하는데 대상이 항상 나(탱커)로 나오는 증상.
    -- 스킬별 대상 찾을때까지는 캐스터바에 대상출력은 보류.
    --castBar.Text:SetText(newCastbarText);

end
--hooksecurefunc("CastingBarFrame_OnShow", LJDUpdateSpellName);