function DebugPrint(arrayInfo, arrayText)

    if not LJDSpellInterruptDB["ShowPrintDebugMsg"] then return nil; end;

    if type(arrayInfo) ~= "table" then
        print(date("%H:%M:%S"),arrayInfo)
        return nil;
    end

    print(date("%H:%M:%S"),"ArrayCount -----------------------------> " ..#arrayInfo);
    for arrayIndex = 1, #arrayInfo do
        local tempvalue = arrayInfo[arrayIndex];
        --print(type(tempvalue));
        if type(tempvalue) ~= "string" then
            tempvalue = tostring(tempvalue);
        end

        if(type(arrayText) ~= "table") then
            print(date("%H:%M:%S"),"arrayInfo["..arrayIndex.."] :"..tempvalue);
        else
            print(date("%H:%M:%S"),"["..arrayIndex.."]<"..arrayText[arrayIndex].."> :"..tempvalue);
        end
    end
end

function DebugPrintTable(argTable, strUserTableName)

    if not LJDSpellInterruptDB["ShowPrintDebugMsg"] then return nil; end;

    local tblName = "NoName";

    strUserTableName = strUserTableName or "";
    print(date("%H:%M:%S"), "------------------------------------------------------");
    print(date("%H:%M:%S"), "<<"..strUserTableName ..">>");
    print(date("%H:%M:%S"), "------------------------------------------------------");

    if type(argTable) ~= "table" then
        print(date("%H:%M:%S"), argTable)
        return nil;
    end

    if( type(argTable.GetName) == "function" ) then
        tblName = argTable:GetName() or "";
    end

    print(date("%H:%M:%S"), "<"..tblName .."> :".. tostring(argTable));

    for i,v in next, argTable do
        print(date("%H:%M:%S"), "  [".. tostring(i) .. "] :" .. tostring(v));
    end
end

function DebugPrintG(strArg)

    local _G = _G;

    if( not strArg ) then
        DebugPrintTable(_G, "_G");
    else
        DebugPrintTable(_G[strArg], "_G[\"" .. strArg .. "\"]");
    end

end


local frame = CreateFrame("FRAME");
frame:SetScript('OnEvent', function(self, event, ...)
    return self[event] and self[event](self, event, ...)
end)

-- 입력창에 명령어를 입력했을때 발생하는데
-- 애드온에서 사용하는 명령어에는 반응하지 않는다.
-- Ex) /jd (반응안함)
--     /fstack (반응)
function frame:EXECUTE_CHAT_LINE(...)
    local ll = {...};
    local command = ll[2];
    local firstWord = command:match("^/(%S+)");
    
    --print(command);
    --print(firstWord);
    
    if firstWord == "fstack" then
       --print(FrameStackTooltip:IsVisible());
       --print(FrameStackHighlight:IsVisible());
        if( FrameStackHighlight ) then
            LJDChangeFuncNoError(FrameStackHighlight, "HighlightFrame");
            LJDChangeFuncNoError("CheckGetRegionsTextureInfo");
            
            --LJDChangeFuncNoError("FrameStackTooltip_OnUpdate");

            --DebugPrint(FrameStackTooltip_OnUpdate);
        end
    end
end
frame:RegisterEvent("EXECUTE_CHAT_LINE");

-- fstack error 관련 수정
-- 함수자체의 주소는 바뀌더라도 원하는 결과를 얻지 못한다.
-- 함수의 부모에서 바꿔야 한다(_G 가 되더라도).
-- 함수에서 함수를 호출한 경우, 하위 함수에서 오류가 발생한 것은 막지 못한다.
LJDOrgFuncList={};
function LJDChangeFuncNoError(arg1, arg2)
    local parent = (type(arg1) == "table") and arg1 or _G;
    local funcName = (type(arg1) == "string") and arg1 or arg2;
    local func = parent[funcName];
    
    if( not func ) then
        DebugPrint("Not Exists Function : "..funcName);
        return;
    end
    
    local function newFunc(...)
        LJDPCall( LJDOrgFuncList[funcName], ...);
    end

    if not LJDOrgFuncList[funcName] then
        LJDOrgFuncList[funcName] = func;
    end
    
    parent[funcName] = newFunc;
end

-- 함수호출
-- 오류가 발생해도 무시하고 실행한다.
function LJDPCall(func, ...)
    local ret = {pcall(func, ...)};
    
    if( not ret[1] ) then
        --DebugPrint(ret);
    end
    
    return select(2, ret);
end

    
