﻿-----------------------------------------------------
-- lua 파일이 여러개인 경우
-- 애드온명, 애드온내공유테이블이 ...으로 전달됨
-----------------------------------------------------
local addonName, addonLocalDB = ...;

local frame = CreateFrame("FRAME");
frame:SetScript('OnEvent', function(self, event, ...)
    return self[event] and self[event](self, event, ...)
end)

function frame:PLAYER_ENTERING_WORLD()
    -- 디버그용
    -- SpellLink 디버그용(접속하는 케릭터가 가진 스킬이어야 함. [초급 타기]는 공용이므로)
    --print(GetSpellLink("초급 타기"));
    --ChangeMoveableFrame(TradeSkillFrame); -- 전문기술
    --print(TradeSkillUI);
end
frame:RegisterEvent('PLAYER_ENTERING_WORLD');

function frame:COMBAT_LOG_EVENT_UNFILTERED()

    local timestamp, type, hideCaster,                                                                                           -- arg1  to arg3
        sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags,                        -- arg4  to arg11
        spellId, spellName, spellSchool,                                                                                           -- arg12 to arg14
        extraSpellId,extraSpellName,extraSchool, resisted, blocked, absorbed, critical, glancing, crushing = CombatLogGetCurrentEventInfo()       -- arg15 to arg23

    --if( type == "SPELL_INTERRUPT" ) then
    if( spellName == "주문 잠금" ) then
        --DebugPrintTable({CombatLogGetCurrentEventInfo()});
    end;

    -- 스킬 시전한 몹, NPC 경우 제외
    -- ex) 몹이 파티원 차단한 경우, NPC에 의한 버프등
    --     Pet 스킬이용한 차단 알림기능 추가(20191122)
    local unittype = strsplit("-",sourceGUID)   -- UID의 "-"로 split후 첫번째인자
    if( unittype ~= "Player" and unittype ~= "Pet" ) then
        --DebugPrintTable({CombatLogGetCurrentEventInfo()});
        return;
    end

  --[[
  local timestamp, type, hideCaster,
    sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = CombatLogGetCurrentEventInfo()

     * Note, for this example, you could just use 'local type = select(2, CombatLogGetCurrentEventInfo())'.  The others are included
       so that it's clear what's available.wwwwwwwe
     * You can also lump all of the arguments into one block (or one really long line):

   ]]

    -- 차단 알림
    if( type == "SPELL_INTERRUPT" ) then

        if( (unittype == "Pet") or (sourceName == UnitName("player"))) then -- 20191122 Pet 추가
            --개인알림
            --print("[차단성공]"..destName.."'s "..GetSpellLink(extraSpellId).." ".." 차단!");
            PlaySound_Success();
            --DEFAULT_CHAT_FRAME:AddMessage("\<차단성공\> ".."|cfff48c00"..destName.."|r".."'s "..GetSpellLink(extraSpellId).." ".." 차단!", 1, 0, 0);
            --UIErrorsFrame     :AddMessage("\<차단성공\> ".."|cfff48c00"..destName.."|r".."'s "..GetSpellLink(extraSpellId).." ".." 차단!", 1, 0, 0);

            --채팅알림
            --SendChatMessage(destName.."'s "..GetSpellLink(extraSpellId).." ".." 차단!", "say");
            --SendChatMessage("(차단)그만하라고!", "say");
            --SendChatMessage("(차단)그만하라고!", "yell");
            --SendChatMessage("(차단)그만하라고!", "whisper", nil,UnitName("player"))
        end

        -- 20191110 차단자 함께 출력하기
        local className, classFilename, classID = UnitClass(sourceName);
        local rPerc, gPerc, bPerc, argbHex = GetClassColor(classFilename);

        --DebugPrintTable({CombatLogGetCurrentEventInfo()});

        DEFAULT_CHAT_FRAME:AddMessage("\<차단성공\> ".."[|c"..argbHex..""..sourceName.."|r]'s "..GetSpellLink(spellId).." -> |cfff48c00"..destName.."|r".."'s "..GetSpellLink(extraSpellId).." ".." 차단!", 1, 0, 0);
        UIErrorsFrame     :AddMessage("\<차단성공\> ".."[|c"..argbHex..""..sourceName.."|r]'s "..GetSpellLink(spellId).." -> |cfff48c00"..destName.."|r".."'s "..GetSpellLink(extraSpellId).." ".." 차단!", 1, 0, 0);
    end

    -- 외생기 감사인사
    if( type == "SPELL_CAST_SUCCESS" and destName == UnitName("player")) then
        if ( sourceName ~= UnitName("player") ) then  -- 내가 시전한 버프 제외

            -- [디버깅]받은 스킬 출력하기
            --print(sourceName.."->"..GetSpellLink(spellId));

            if( isExternalLifeBuffSkill(spellName) ) then
                SendChatMessage(sourceName.."님 ["..GetSpellLink(spellId).."] 감사해요~", "say");
            end
        end
    end

    --[[ 차단 알림 기능 강화( 차단 스킬 이외 차단시에도 알림 기능 )
    if( type == "SPELL_CAST_START" and sourceName ~= UnitName("player")) then
            local ll = {CombatLogGetCurrentEventInfo()};
            DebugPrint(sourceName.."["..spellName.."] Casting..");
    end
    if( type == "SPELL_CAST_SUCCESS" and sourceName ~= UnitName("player")) then
            local ll = {CombatLogGetCurrentEventInfo()};
            DebugPrint(sourceName.."["..spellName.."] Done!");
    end


    if( type == "SPELL_CAST_FAILED" and sourceName ~= UnitName("player")) then
            local ll = {CombatLogGetCurrentEventInfo()};
            DebugPrintTable(ll);
        if( extraSpellId == "방해를 받아 취소되었습니다." ) then
            print("SPELL_CAST_FAILED");

        end
    end
    --]]
end
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");

function frame:PLAYER_REGEN_DISABLED(...)
    --print("Start Combat");
end
--frame:RegisterEvent("PLAYER_REGEN_DISABLED");

function frame:PLAYER_REGEN_ENABLED(...)
    --print("End Combat");
    --UseItemByName("원거리 획득기");
end
--frame:RegisterEvent("PLAYER_REGEN_ENABLED");
